> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.ntropy.com/documentation/api/personalization/filter-patch-v-3-rules-id-patch/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.ntropy.com/_mcp/server. # Modify an existing rule PATCH https://api.ntropy.com/v3/rules/{id} Content-Type: application/json Modify an existing rule in the ruleset. Reference: https://docs.ntropy.com/documentation/api/personalization/filter-patch-v-3-rules-id-patch ## Authentication - `X-Api-Key` header (required) — API Key authentication via header ## Request ### Path parameters - `id` (string, required) ### Body (application/json) This endpoint expects an Action. - `Action` ## Response ### 200 Successful Response - `id` (integer, required) ## Errors ### 400 Bad Request Error Provided index does not exist in ruleset - `any` ### 422 Unprocessable Entity Error Validation Error - `detail` (list of ValidationError, optional) ## Types ### If - `if` (Expr, required) - `then` (list of Action, optional) - `else` (list of Action, optional) ### Setter - `set` (enum, required) - Allowed values: `logo`, `website`, `merchant`, `merchant_id`, `location`, `person`, `transaction_type` - `to` (Expr, required) ### ValidationError - `loc` (list of ValidationErrorLocItems, required) - `msg` (string, required) - `type` (string, required) ### Expr ### Action ### ValidationErrorLocItems ## Examples ### Example_0 **Request** ```json { "body": { "if": {} } } ``` **Response** ```json { "id": 42, "add_label": "vip_customer" } ``` **SDK Code** ```python Example_0 import requests url = "https://api.ntropy.com/v3/rules/id" payload = { "body": { "if": {} } } headers = { "X-Api-Key": "", "Content-Type": "application/json" } response = requests.patch(url, json=payload, headers=headers) print(response.json()) ``` ```javascript Example_0 const url = 'https://api.ntropy.com/v3/rules/id'; const options = { method: 'PATCH', headers: {'X-Api-Key': '', 'Content-Type': 'application/json'}, body: '{"body":{"if":{}}}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go Example_0 package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.ntropy.com/v3/rules/id" payload := strings.NewReader("{\n \"body\": {\n \"if\": {}\n }\n}") req, _ := http.NewRequest("PATCH", url, payload) req.Header.Add("X-Api-Key", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby Example_0 require 'uri' require 'net/http' url = URI("https://api.ntropy.com/v3/rules/id") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Patch.new(url) request["X-Api-Key"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"body\": {\n \"if\": {}\n }\n}" response = http.request(request) puts response.read_body ``` ```java Example_0 import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.patch("https://api.ntropy.com/v3/rules/id") .header("X-Api-Key", "") .header("Content-Type", "application/json") .body("{\n \"body\": {\n \"if\": {}\n }\n}") .asString(); ``` ```php Example_0 request('PATCH', 'https://api.ntropy.com/v3/rules/id', [ 'body' => '{ "body": { "if": {} } }', 'headers' => [ 'Content-Type' => 'application/json', 'X-Api-Key' => '', ], ]); echo $response->getBody(); ``` ```csharp Example_0 using RestSharp; var client = new RestClient("https://api.ntropy.com/v3/rules/id"); var request = new RestRequest(Method.PATCH); request.AddHeader("X-Api-Key", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"body\": {\n \"if\": {}\n }\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift Example_0 import Foundation let headers = [ "X-Api-Key": "", "Content-Type": "application/json" ] let parameters = ["body": ["if": []]] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.ntropy.com/v3/rules/id")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "PATCH" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` ### cURL **SDK Code** ```python Python SDK from ntropy_sdk import SDK sdk = SDK("cd1H...Wmhl") rule = sdk.rules.patch( "42c87677-ff07-4428-a76d-d596cc80c057", {"set": "logo", "to": "http://example.com/favicon.ico"}, ) ``` ```javascript cURL const url = 'https://api.ntropy.com/v3/rules/:id'; const options = {method: 'PATCH', headers: {'X-Api-Key': ''}}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go cURL package main import ( "fmt" "net/http" "io" ) func main() { url := "https://api.ntropy.com/v3/rules/:id" req, _ := http.NewRequest("PATCH", url, nil) req.Header.Add("X-Api-Key", "") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby cURL require 'uri' require 'net/http' url = URI("https://api.ntropy.com/v3/rules/:id") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Patch.new(url) request["X-Api-Key"] = '' response = http.request(request) puts response.read_body ``` ```java cURL import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.patch("https://api.ntropy.com/v3/rules/:id") .header("X-Api-Key", "") .asString(); ``` ```php cURL request('PATCH', 'https://api.ntropy.com/v3/rules/:id', [ 'headers' => [ 'X-Api-Key' => '', ], ]); echo $response->getBody(); ``` ```csharp cURL using RestSharp; var client = new RestClient("https://api.ntropy.com/v3/rules/:id"); var request = new RestRequest(Method.PATCH); request.AddHeader("X-Api-Key", ""); IRestResponse response = client.Execute(request); ``` ```swift cURL import Foundation let headers = ["X-Api-Key": ""] let request = NSMutableURLRequest(url: NSURL(string: "https://api.ntropy.com/v3/rules/:id")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "PATCH" request.allHTTPHeaderFields = headers let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```